#ifndef CLIST_HEADER
#define CLIST_HEADER

typedef struct st_ListNode
{
	void*   vp_Content;
	struct  st_ListNode* p_Next;
	struct  st_ListNode* p_Prev;
} t_ListNode;

typedef struct st_List
{
	struct  st_ListNode* p_Current;
	struct  st_ListNode* p_Top;
	struct  st_ListNode* p_Bottom;
} t_List;

t_List*	ListCreate ();
int		ListSetStart	( t_List* p_List );
int		ListSetEnd	( t_List* p_List );
int		ListPushFront	( t_List* p_List, void* vp_Content );
int		ListPushBack	( t_List* p_List, void* vp_Content );
void*		ListPopFront	( t_List* p_List );
void*		ListPopBack	( t_List* p_List );
void*		ListTop		( t_List* p_List );
int		ListCurrent	( t_List* p_List );
void*		ListNext	( t_List* p_List );
void*		ListPrev	( t_List* p_List );
int		ListEmpty	( t_List* p_List );
void		ListDestroy	( t_List* p_List );

#endif
